"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
require("./index.css");
var _reactFontawesome = require("@fortawesome/react-fontawesome");
var _freeBrandsSvgIcons = require("@fortawesome/free-brands-svg-icons");
var _freeSolidSvgIcons = require("@fortawesome/free-solid-svg-icons");
var _freeRegularSvgIcons = require("@fortawesome/free-regular-svg-icons");
require("@fortawesome/fontawesome-svg-core/styles.css");
var _fontawesomeSvgCore = require("@fortawesome/fontawesome-svg-core");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
_fontawesomeSvgCore.library.add(_freeBrandsSvgIcons.fab, _freeSolidSvgIcons.fas, _freeRegularSvgIcons.far);
var IconsPerPage = 20;
var IconSelectTest = function IconSelectTest(_ref) {
  var icons = _ref.icons,
    onIconClick = _ref.onIconClick,
    renderTrigger = _ref.renderTrigger;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isPopupVisible = _useState2[0],
    setIsPopupVisible = _useState2[1];
  var _useState3 = (0, _react.useState)({
      top: '0px',
      left: '0px'
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    popupPosition = _useState4[0],
    setPopupPosition = _useState4[1];
  var buttonRef = (0, _react.useRef)(null);
  var handleOpenPopup = function handleOpenPopup() {
    var rect = buttonRef.current.getBoundingClientRect();
    setPopupPosition({
      top: "".concat(rect.bottom + window.scrollY - 44, "px"),
      left: "".concat(rect.left, "px")
    });
    setIsPopupVisible(!isPopupVisible);
  };
  var handleClosePopup = function handleClosePopup() {
    setIsPopupVisible(false);
  };
  (0, _react.useEffect)(function () {
    var handleClickOutside = function handleClickOutside(event) {
      if (buttonRef.current && !buttonRef.current.contains(event.target) && !event.target.closest('.popup-container')) {
        handleClosePopup();
      }
    };
    document.addEventListener('mousedown', handleClickOutside);
    return function () {
      document.removeEventListener('mousedown', handleClickOutside);
    };
  }, [buttonRef]);
  var categories = Object.keys(icons);
  var filterIcons = function filterIcons(searchQuery, selectedCategory) {
    var allIcons = selectedCategory === 'All' ? Object.values(icons).flat() : icons[selectedCategory];
    return allIcons.filter(function (icon) {
      return icon.toLowerCase().includes(searchQuery.toLowerCase());
    });
  };
  var _useState5 = (0, _react.useState)(1),
    _useState6 = _slicedToArray(_useState5, 2),
    currentPage = _useState6[0],
    setCurrentPage = _useState6[1];
  var _useState7 = (0, _react.useState)('All'),
    _useState8 = _slicedToArray(_useState7, 2),
    selectedCategory = _useState8[0],
    setSelectedCategory = _useState8[1];
  var _useState9 = (0, _react.useState)(''),
    _useState10 = _slicedToArray(_useState9, 2),
    searchQuery = _useState10[0],
    setSearchQuery = _useState10[1];
  var filteredIcons = filterIcons(searchQuery, selectedCategory);
  var totalPages = Math.ceil(filteredIcons.length / IconsPerPage);
  var handlePageChange = function handlePageChange(direction) {
    setCurrentPage(function (prevPage) {
      return Math.max(1, Math.min(totalPages, prevPage + direction));
    });
  };
  var startIdx = (currentPage - 1) * IconsPerPage;
  var endIdx = startIdx + IconsPerPage;
  var iconsToDisplay = filteredIcons.slice(startIdx, endIdx);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "relative"
  }, renderTrigger(handleOpenPopup, buttonRef), isPopupVisible && /*#__PURE__*/_react["default"].createElement("div", {
    className: "absolute bg-white border border-gray-300 shadow-lg rounded z-50 popup-container",
    style: {
      top: popupPosition.top,
      left: popupPosition.left
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex flex-col items-center p-4"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex flex-col mb-5 w-full"
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    placeholder: "Search icons...",
    value: searchQuery,
    onChange: function onChange(e) {
      setSearchQuery(e.target.value);
      setCurrentPage(1); // Reset to first page on search change
    },
    className: "mb-2 py-2 text-base border-gray-300 border-b outline-none"
  }), /*#__PURE__*/_react["default"].createElement("select", {
    value: selectedCategory,
    onChange: function onChange(e) {
      setSelectedCategory(e.target.value);
      setCurrentPage(1); // Reset to first page on filter change
    },
    className: "py-2 text-base border-gray-300 border-b bg-transparent outline-none"
  }, /*#__PURE__*/_react["default"].createElement("option", {
    value: "All"
  }, "All Categories"), categories.map(function (category, index) {
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: index,
      value: category
    }, category);
  }))), iconsToDisplay.length > 0 && /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-full flex justify-between items-center mb-2"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center gap-2"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "border-gray-300 border-b w-8 text-right"
  }, currentPage), /*#__PURE__*/_react["default"].createElement("span", null, "/ ", totalPages)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center"
  }, /*#__PURE__*/_react["default"].createElement("button", {
    onClick: function onClick() {
      return handlePageChange(-1);
    },
    disabled: currentPage === 1,
    className: "bg-transparent border-none bg-gray-200 text-gray-600 rounded cursor-pointer mx-2 px-2 transition-colors duration-300 hover:bg-gray-200 disabled:opacity-50"
  }, /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: "angle-left"
  })), /*#__PURE__*/_react["default"].createElement("button", {
    onClick: function onClick() {
      return handlePageChange(1);
    },
    disabled: currentPage === totalPages,
    className: "bg-transparent border-none bg-gray-200 text-gray-600 rounded cursor-pointer px-2 transition-colors duration-300 hover:bg-gray-200 disabled:opacity-50"
  }, /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: "angle-right"
  })))), iconsToDisplay.length === 0 ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-gray-500"
  }, "No icons found") : /*#__PURE__*/_react["default"].createElement("div", {
    className: "grid grid-cols-5 grid-rows-4 gap-[2px] w-fit"
  }, iconsToDisplay.map(function (icon, index) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: index,
      className: "w-[65px] h-[65px] bg-gray-200 flex justify-center items-center cursor-pointer group hover:bg-gray-300",
      onClick: function onClick() {
        return onIconClick(icon);
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
      icon: icon,
      className: "text-gray-800 text-[20px] transform transition duration-200 group-hover:text-gray-600 group-hover:scale-150"
    }));
  })))));
};
IconSelectTest.propTypes = {
  icons: _propTypes["default"].object.isRequired,
  onIconClick: _propTypes["default"].func.isRequired,
  renderTrigger: _propTypes["default"].func.isRequired
};
var _default = exports["default"] = IconSelectTest;